+
+ ## Set DIR_TMP using DIR_TMP_PARENT and nonce (SCRIPT_TIME_START)
+ DIR_TMP="$DIR_TMP_PARENT"/"$SCRIPT_TIME_START""..bkgpslog" && vbm "DEBUG:Set DIR_TMP to:$DIR_TMP"; # Note: removed at end of main().
+
+ # Set output encryption and compression option strings
+ if [[ "$OPTION_ENCRYPT" = "true" ]]; then # Check if encryption option active.
+ if checkapp age; then # Check that age is available.
+ for pubkey in "${recPubKeys[@]}"; do # Validate recipient pubkey strings by forming test message
+ vbm "DEBUG:Testing pubkey string:$pubkey"
+ if echo "butts" | age -a -r "$pubkey" 1>/dev/null; then
+ # Form age recipient string
+ recipients="$recipients""-r $pubkey ";
+ vbm "STATUS:Added pubkey for forming age recipient string:""$pubkey";
+ vbm "DEBUG:recipients:""$recipients";
+ else
+ yell "ERROR:Exit code ""$?"". Invalid recipient pubkey string. Exiting."; exit 1;
+ fi
+ done
+ vbm "DEBUG:Finished processing recPubKeys array";
+ # Form age command string
+ CMD_ENCRYPT="age ""$recipients ";
+ CMD_ENCRYPT_SUFFIX=".age";
+ else
+ yell "ERROR:Encryption enabled but \"age\" not found. Exiting."; exit 1;
+ fi
+ else
+ CMD_ENCRYPT="tee /dev/null ";
+ CMD_ENCRYPT_SUFFIX="";
+ vbm "DEBUG:Encryption not enabled."
+ fi
+ if [[ "$OPTION_COMPRESS" = "true" ]]; then # Check if compression option active
+ if checkapp gzip; then # Check if gzip available
+ CMD_COMPRESS="gzip ";
+ CMD_COMPRESS_SUFFIX=".gz";
+ else
+ yell "ERROR:Compression enabled but \"gzip\" not found. Exiting."; exit 1;
+ fi
+ else
+ CMD_COMPRESS="tee /dev/null ";
+ CMD_COMPRESS_SUFFIX="";
+ vbm "DEBUG:Compression not enabled."
+ fi
+
+ # Check that critical apps and dirs are available, displag missing ones.
+ if ! checkapp gpspipe tar && ! checkdir "$DIR_OUT" "/dev/shm"; then
+ yell "ERROR:Critical components missing.";
+ displayMissing; yell "Exiting."; exit 1; fi
+
+ # Set script lifespan
+ setScriptTTL "$SCRIPT_TTL";
+
+ # File name substring: encoded bufferTTL
+ bufferTTL_STR="$(timeDuration $BUFFER_TTL)";
+
+ # Init temp working dir
+ try mkdir "$DIR_TMP" && vbm "DEBUG:Working dir creatd at:$DIR_TMP";
+
+ # Initialize 'tar' archive
+ ## Define output tar path (note: each day gets *one* tar file (Ex: "20200731..hostname_location.[.gpx.gz].tar"))
+ PATHOUT_TAR="$DIR_OUT"/"$(dateShort)".."$SCRIPT_HOSTNAME""_location""$CMD_COMPRESS_SUFFIX""$CMD_ENCRYPT_SUFFIX".tar && \
+ vbm "STATUS:Set PATHOUT_TAR to:$PATHOUT_TAR";
+ ## Write bkgpslog version to DIR_TMP/VERSION
+ echo "$0"" Version:""$SCRIPT_VERSION" >> "$DIR_TMP/VERSION" && vbm "DEBUG:VERSION created.";
+ ## Check if PATHOUT_TAR already exists.
+ if [[ -f "$PATHOUT_TAR" ]]; then
+ vbm "STATUS:Output tar already exists:$PATHOUT_TAR";
+ ### Check if preexisting tar is appendable.
+ PATHOUT_APPENDTEST="$DIR_TMP"/"$(dateTimeShort)..RESUMING_LOGGING_SESSION.txt" && \
+ vbm "DEBUG:Set PATHOUT_APPENDTEST to:$PATHOUT_APPENDTEST";
+ echo "$(dateTimeShort):""$(basename "$0")"" version $SCRIPT_VERSION resuming logging session." >> "$PATHOUT_APPENDTEST" && \
+ vbm "DEBUG:""$PATHOUT_APPENDTEST"" created."
+ if ! tar --append --directory="$DIR_TMP" --file="$PATHOUT_TAR" "$(basename "$PATHOUT_APPENDTEST")"; then
+ ### If not appendable, label tar broken, move tar, proceed.
+ mv "$PATHOUT_TAR" "${PATHOUT_TAR%.*}""-broken$(dateTimeShort)".tar && \
+ vbm "DEBUG:tar not writable, moving out of the way $PATHOUT_TAR";
+ fi
+ else
+ vbm "STATUS:Output tar does not already exist. Creating:$PATHOUT_TAR"
+ ### If (no preexisting|appendable) tar found, create empty tar archive at PATHOUT_TAR
+ try tar --create --directory="$DIR_TMP" --file="$PATHOUT_TAR" --files-from=/dev/null && \
+ vbm "DEBUG:Empty tar created at:$PATHOUT_TAR";
+ fi
+ ## Append VERSION file to PATHOUT_TAR
+ try tar --append --directory="$DIR_TMP" --file="$PATHOUT_TAR" "VERSION" && \
+ vbm "DEBUG:VERSION added to $PATHOUT_TAR";
+
+ # Record gps data until script lifespan ends
+ declare debugCounter; debugCounter="0"; # set debug counter
+ timeStart=$(dateTimeShort); # Note start time
+ while [[ "$SECONDS" -lt "$scriptTTL" ]]; do
+ # Determine file paths (time is start of buffer period)
+ FILEOUT_BASENAME="$timeStart""--""$bufferTTL_STR""..""$SCRIPT_HOSTNAME""_location" && vbm "STATUS:Set FILEOUT_BASENAME to:$FILEOUT_BASENAME";
+ ## Files saved to DIR_TMP
+ PATHOUT_NMEA="$DIR_TMP"/"$FILEOUT_BASENAME".nmea"$CMD_COMPRESS_SUFFIX""$CMD_ENCRYPT_SUFFIX" && vbm "STATUS:Set PATHOUT_NMEA to:$PATHOUT_NMEA";
+ PATHOUT_GPX="$DIR_TMP"/"$FILEOUT_BASENAME".gpx"$CMD_COMPRESS_SUFFIX""$CMD_ENCRYPT_SUFFIX" && vbm "STATUS:Set PATHOUT_GPX to:$PATHOUT_GPX";
+ PATHOUT_KML="$DIR_TMP"/"$FILEOUT_BASENAME".kml"$CMD_COMPRESS_SUFFIX""$CMD_ENCRYPT_SUFFIX" && vbm "STATUS:Set PATHOUT_KML to:$PATHOUT_KML";
+ ## Files saved to disk (DIR_OUT)
+ ### one file per day (Ex: "20200731..hostname_location.[.gpx.gz].tar")
+ PATHOUT_TAR="$DIR_OUT"/"$(dateShort)".."$SCRIPT_HOSTNAME""_location""$CMD_COMPRESS_SUFFIX""$CMD_ENCRYPT_SUFFIX".tar && \
+ vbm "STATUS:Set PATHOUT_TAR to:$PATHOUT_TAR"
+ # Define GPS conversion commands
+ CMD_CONV_NMEA="tee /dev/null " && vbm "STATUS:Set CMD_CONV_NMEA to:$CMD_CONV_NMEA"; # tee as passthrough
+ CMD_CONV_GPX="gpsbabel -i nmea -f - -o gpx -F - " && vbm "STATUS:Set CMD_CONV_GPX to:$CMD_CONV_GPX"; # convert NMEA to GPX
+ CMD_CONV_KML="gpsbabel -i nmea -f - -o kml -F - " && vbm "STATUS:Set CMD_CONV_KML to:$CMD_CONV_KML"; # convert NMEA to KML
+ # Fill Bash variable buffer
+ bufferBash="$(timeout "$BUFFER_TTL""s" gpspipe -r)" && vbm "STATUS:Successfully filled bufferBash variable with gpspipe data."; # Record gpspipe nmea data to buffer for bufferTTL seconds
+ # Process bufferBash, save secured chunk set to DIR_TMP
+ vbm "STATUS:Beginning to save data to $DIR_TMP";
+ echo "$bufferBash" | $CMD_CONV_NMEA | $CMD_COMPRESS | $CMD_ENCRYPT > "$PATHOUT_NMEA" & # Create NMEA file (secured if requested)
+ echo "$bufferBash" | $CMD_CONV_GPX | $CMD_COMPRESS | $CMD_ENCRYPT > "$PATHOUT_GPX" & # Create GPX file (secured if requested)
+ echo "$bufferBash" | $CMD_CONV_KML | $CMD_COMPRESS | $CMD_ENCRYPT > "$PATHOUT_KML" & # Create KML file (secured if requested)
+ # Append each secured chunk in memory dir (DIR_TMP) to file on disk (PATHOUT_TAR in DIR_OUT)
+ vbm "STATUS:DIR_TMP :$DIR_TMP";
+ vbm "STATUS:PATHOUT_TAR :$PATHOUT_TAR";
+ vbm "STATUS:PATHOUT_NMEA:$PATHOUT_NMEA";
+ vbm "STATUS:PATHOUT_NMEA:$PATHOUT_GPX";
+ vbm "STATUS:PATHOUT_NMEA:$PATHOUT_KML";
+ try tar --append --directory="$DIR_TMP" --file="$PATHOUT_TAR" "$(basename "$PATHOUT_NMEA")" && \
+ vbm "DEBUG:Appended NMEA location data $PATHOUT_NMEA to $PATHOUT_TAR";
+ try tar --append --directory="$DIR_TMP" --file="$PATHOUT_TAR" "$(basename "$PATHOUT_GPX")" && \
+ vbm "DEBUG:Appended GPX location data $PATHOUT_GPX to $PATHOUT_TAR";
+ try tar --append --directory="$DIR_TMP" --file="$PATHOUT_TAR" "$(basename "$PATHOUT_KML")" && \
+ vbm "DEBUG:Appended KML location $PATHOUT_KML to $PATHOUT_TAR";
+ # Remove secured chunks from DIR_TMP
+ try rm "$PATHOUT_NMEA" "$PATHOUT_GPX" "$PATHOUT_KML";
+ # Reset buffer and filenames
+ unset bufferBash FILEOUT_BASENAME PATHOUT_NMEA PATHOUT_GPX PATHOUT_KML PATHOUT_TAR;
+ vbm "DEBUG:Completed buffer session $debugCounter ." 1>&2;
+ ((debugCounter++))
+ done
+
+ # Remove DIR_TMP
+ try rm -r "$DIR_TMP";